<!doctype html>
<html>
    <head>
      <title>Grip Bar | <?php echo($page->title); ?></title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <link rel = "stylesheet" type = "text/css" href = "<?=$config->urls->templates;?>styles/styles.css">
        <link rel = "stylesheet" type = "text/css" href = "<?=$config->urls->templates;?>styles/print.css">

        <link rel="apple-touch-icon" sizes="57x57" href="/apple-icon-57x57.png">
        <link rel="apple-touch-icon" sizes="60x60" href="/apple-icon-60x60.png">
        <link rel="apple-touch-icon" sizes="72x72" href="/apple-icon-72x72.png">
        <link rel="apple-touch-icon" sizes="76x76" href="/apple-icon-76x76.png">
        <link rel="apple-touch-icon" sizes="114x114" href="/apple-icon-114x114.png">
        <link rel="apple-touch-icon" sizes="120x120" href="/apple-icon-120x120.png">
        <link rel="apple-touch-icon" sizes="144x144" href="/apple-icon-144x144.png">
        <link rel="apple-touch-icon" sizes="152x152" href="/apple-icon-152x152.png">
        <link rel="apple-touch-icon" sizes="180x180" href="/apple-icon-180x180.png">
        <link rel="icon" type="image/png" sizes="192x192" href="/android-icon-192x192.png">
        <link rel="icon" type="image/png" sizes="32x32" href="/favicon-32x32.png">
        <link rel="icon" type="image/png" sizes="96x96" href="/favicon-96x96.png">
        <link rel="icon" type="image/png" sizes="16x16" href="/favicon-16x16.png">
        <link rel="manifest" href="/manifest.json">
        <meta name="msapplication-TileColor" content="#ffffff">
        <meta name="msapplication-TileImage" content="/ms-icon-144x144.png">
        <meta name="theme-color" content="#ffffff">

        <link rel="stylesheet" href="https://unpkg.com/flickity@2/dist/flickity.min.css">
        <script src="https://unpkg.com/flickity@2/dist/flickity.pkgd.min.js"></script>

        <link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/uikit/2.26.3/css/components/slideshow.min.css'/>
   	    <link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/uikit/2.26.3/css/components/sticky.min.css'/>
        <link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/uikit/2.26.3/css/components/notify.min.css'/>
        <link rel='stylesheet' href='https://cdnjs.cloudflare.com/ajax/libs/uikit/2.26.3/css/components/slidenav.min.css'/>
        <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
        <link href="https://fonts.googleapis.com/css?family=Ubuntu" rel="stylesheet">

        <!--Language SEO-->
        <?php $contact = $pages->get(1021);
        $locale = $user->language->name;
        if ($locale == "default") {
          $locale = "en";
        }
        echo "<meta http-equiv='content-language' content='$locale'>";
          foreach ($languages as $language) {
            $locale = $language->name;
            if ($locale == "default") {
              $locale = "en";
            }
            $url = $page->localUrl($language);

            echo "<link rel='alternative' hreflang='$locale'
                        href='$url' />";
          }
        ?>

    </head>
    <body class = "uk-animation-fade">
      <?php $settings = $pages->get(1020)?>
        <header data-uk-sticky>
            <a href = "/"><?php $logo = $settings->site_logo;
            echo "<img src = '{$logo->url}' alt = '{$logo->description}' />" ?></a>
            <div>
                <?php
                echo "<h2><a target='_blank' href = \"mailto: $contact->contact_email\"><i class='uk-icon-envelope uk-icon-small'></i>$contact->contact_email</a></h2>";
                echo "<h2><i class='uk-icon-phone uk-icon-small'></i>$contact->telephone</h2>";?>
                <select class="language__select" onchange='window.location=$(this).val();'>
                <?php
                foreach($languages as $language) {
                  $selected = '';

                  // if this page isn't viewable (active) for the language, skip it
                  if(!$page->viewable($language)) continue;

                  // if language is current user's language, make it selected
                  if($user->language->id == $language->id) $selected = " selected=selected";

                  // determine the "local" URL for this language
                  $url = $page->localUrl($language);

                  // output the option tag
                  echo "<option$selected value='$url'>$language->title</option>";
                }
                ?>
                </select>
                <ul class = "navigation">
                <?php $home = $pages->get("/"); foreach($home->children()->prepend($home) as $menu): ?>
                    <li></i> <a href="<?=$menu->url?>"><?=$menu->get("menu_title|title")?></a></li>
                <?php endforeach; ?>
                </ul>
                <div class="outer-menu">
                    <input class="checkbox-toggle" type="checkbox" />
                    <div class="hamburger">
                        <div></div>
                    </div>
                    <div class="menu">
                        <div>
                            <div>
                                <ul>
                                    <?php $home = $pages->get("/"); foreach($home->children()->prepend($home) as $menu): ?>
                                        <li></i> <a href="<?=$menu->url?>"><?=$menu->get("menu_title|title")?></a></li>
                                    <?php endforeach; ?>
                                    <select class="language__select--mobile" onchange='window.location=$(this).val();'>
                                    <?php
                                    foreach($languages as $language) {
                                      $selected = '';

                                      // if this page isn't viewable (active) for the language, skip it
                                      if(!$page->viewable($language)) continue;

                                      // if language is current user's language, make it selected
                                      if($user->language->id == $language->id) $selected = " selected=selected";

                                      // determine the "local" URL for this language
                                      $url = $page->localUrl($language);

                                      // output the option tag
                                      echo "<option$selected value='$url'>$language->title</option>";
                                    }
                                    ?>
                                    </select>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </header>
